// Generated by CoffeeScript 2.5.1
// Export Plugin
var hasProp = {}.hasOwnProperty;

module.exports = function(BasePlugin) {
  var StylusPlugin;
  return StylusPlugin = (function() {
    // Define Plugin
    class StylusPlugin extends BasePlugin {
      // Render some content
      render(opts, next) {
        var config, content, file, inExtension, library, option, outExtension, ref, ref1, style, stylus, value;
        // Prepare
        ({inExtension, outExtension, content, file} = opts);
        config = this.getConfig();
        stylus = config.stylusRequire || require('stylus');
        // Check extensions
        if ((inExtension === 'styl' || inExtension === 'stylus') && (outExtension === 'css' || outExtension === null)) {
          // Create our style
          style = stylus(opts.content).set('filename', file.get('fullPath'));
          ref = config.stylusOptions;
          for (option in ref) {
            if (!hasProp.call(ref, option)) continue;
            value = ref[option];
            if (option === 'resolve url') {
              style.define('url', stylus.resolver(value));
            } else {
              style.set(option, value);
            }
          }
          ref1 = config.stylusLibraries;
          for (library in ref1) {
            if (!hasProp.call(ref1, library)) continue;
            value = ref1[library];
            if (!value) {
              continue;
            }
            if (value === true) {
              value = void 0;
            }
            style.use(require(library)(value));
          }
          // Render our style
          return style.render(function(err, output) {
            if (err) {
              // Check for errors, and return to docpad if so
              return next(err);
            }
            // Apply result
            opts.content = output;
            // Done, return to docpad
            return next();
          });
        } else {
          // Nothing to do, return back to DocPad
          // Some other extension
          return next();
        }
      }

    };

    // Plugin name
    StylusPlugin.prototype.name = 'stylus';

    // Plugin config
    StylusPlugin.prototype.config = {
      stylusRequire: null,
      stylusLibraries: {
        nib: true
      },
      stylusOptions: {
        compress: true,
        'include css': true
      },
      environments: {
        development: {
          stylusOptions: {
            compress: false
          }
        }
      }
    };

    return StylusPlugin;

  }).call(this);
};
